# Ignore the following warning: InsecureRequestWarning: Unverified HTTPS request is being made to host 'gedbas.genealogy.net'. Adding certificate verification is strongly advised. See: https://urllib3.readthedocs.io/en/1.26.x/advanced-usage.html#ssl-warnings
import urllib3

urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

# Scraper based on introduction on https://towardsdatascience.com/how-to-web-scrape-with-python-in-4-minutes-bc49186a8460
# published from Julia Kho on 27 September 2019, last open on 2 July 2021

# import of libraries
import requests
from bs4 import BeautifulSoup
import io

# initialisation of counters
number = 0
found = 0
notAllowed = 0
notFound = 0
notFoundSeries = 0
end = 10000
empty = 0

# possible GEDCOM files were determined by varying the URL
# the end of the URL is changed with a number that is incremented
# execution of the iteration until no result is found 10000 times (value of variable "end")
while notFoundSeries != end:
    # definition of the URL
    url = "https://gedbas.genealogy.net/gedcom/export/" + str(number)
    try:
        # scraping the information
        response = requests.get(url, verify=False)
        gedcom = str(BeautifulSoup(response.text, "html.parser"))
        # analysis of the information
        # with "not allowed" no public access to the file is possible
        # with "not found", the file is not (no longer) available
        # in all other cases the information is written to a GEDCOM file
        if gedcom != "not found" and gedcom != "not allowed" and gedcom != "":
            filename = str(number) + ".ged"
            file = io.open(filename, "w", encoding="utf-8")
            file.write(gedcom)
            file.close()
            # count number of detected files
            found = found + 1
            # resetting the counter that counts the number of unsuccessful calls in series
            notFoundSeries = 0
        # count number of not allowed files
        if gedcom == "not allowed":
            notAllowed = notAllowed + 1
            notFoundSeries = 0
        # count number of not more existing files
        if gedcom == "not found":
            notFound = notFound + 1
            notFoundSeries = notFoundSeries + 1
        # count number of empty gedcom files
        if gedcom == "":
            empty = empty + 1
            notFoundSeries = 0
    except:
        print("Status: There is an error in file " + str(number) + ".")
    # gives info every 1000 urls
    if number % 1000 == 0:
        print("Status:", str(number) + " urls were analyzed")
    # count up per analysed URL
    number = number + 1

# printing status information
print("Status: Scraping finished")
print("Status: " + str(found) + " files could be found")
print("Status: Access was denied for " + str(notAllowed) + " files")
print("Status: " + str(notFound - end) + " files were deleted")
print("Status: " + str(empty) + " files were blank")
